BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local BSC_GROUP_SIZE_MAX = 12

local SYNERGYLIST = { }
local TSG_LIST = { }

local GROUP_INFO = { }
local GROUP_UNITID = { }

local debug_mode = false
function BSCAS.TrackGroupDebugMode()
	if debug_mode then
		debug_mode = false
		BSCAS:PrintDebug("Debug Mode (Tracking) Disabled!")			
	else
		debug_mode = true		
		BSCAS:PrintDebug("Debug Mode (Tracking) Enabled!")		
	end
end
-- Tracking id's
local function UpdateEnabled()
	SYNERGYLIST = { 
		[ABILITYID_CD_BLOOD_FUNNEL]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BLOODALTAR, 	id = 1,  bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BLOOD_FUNNEL),  	}, 				
		[ABILITYID_CD_FEAST_FUNNEL]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BLOODALTAR, 	id = 1,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_FEAST_FUNNEL),  	}, 	
		[ABILITYID_CD_SPAWNBROODLING]		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS, 		id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SPAWNBROODLING),  	},
		[ABILITYID_CD_BLACK_WIDOW]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS, 		id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BLACK_WIDOW),  	}, 	
		[ABILITYID_CD_ARACHNOPHOBIA]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS, 		id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_ARACHNOPHOBIA),	}, 	
		[ABILITYID_CD_BONE_WALL]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BONESHIELD,	id = 3,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BONE_WALL),		}, 
		[ABILITYID_CD_SPINALSURGE]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BONESHIELD,	id = 3,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SPINALSURGE),  	}, 
		[ABILITYID_CD_SHARTBUBLE_1]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_1),  	}, 
		[ABILITYID_CD_SHARTBUBLE_2]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_2),  	}, 
		[ABILITYID_CD_SHARTBUBLE_3]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_3),  	}, 
		[ABILITYID_CD_HEALING_COMBUSTION]	= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_HEALING_COMBUSTION), },
		[ABILITYID_CD_PURIFY]  				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PURIFY,		id = 5,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PURIFY),  			}, 
		[ABILITYID_CD_CONDUIT]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CONDUIT,		id = 6,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_CONDUIT),  		}, 
		[ABILITYID_CD_CHARGED_LIGHTNING]  	= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.ATRONACH,		id = 7,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_CHARGED_LIGHTNING),}, 
		[ABILITYID_CD_SHACKLE]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHACKLE,		id = 8,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHACKLE),  		},  
		[ABILITYID_CD_IGNITE]  				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHACKLE,		id = 8,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_IGNITE),  			}, 
		[ABILITYID_CD_HARVEST]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HARVEST,		id = 9,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_HARVEST), 			}, 
		[ABILITYID_CD_GRAVEROBBER] 			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GRAVEROBBER, 	id = 10, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_GRAVEROBBER), 		}, 
		[ABILITYID_CD_PURE_AGONY] 			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PUREAGONY,		id = 11, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PURE_AGONY), 		}, 
		[ABILITYID_CD_FEEDING_FRENZY]  		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HOWLING,		id = 12, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_FEEDING_FRENZY), 	}, 
		[ABILITYID_CD_RUNE]  				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.RUNE,			id = 17, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_RUNE), 			}, 
		[ABILITYID_CD_PORTAL]  				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PORTAL,		id = 18, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PORTAL), 			}, 
		[ABILITYID_CD_INNERFIRE]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.INNERFIRE,		id = 23, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_INNERFIRE), 		}, 
		-- Set synergies
		[ABILITYID_CD_URSUS]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.URSUS,			id = 13, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_URSUS), 		}, 
		[ABILITYID_URSUS]					= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.URSUS,			id = 13, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_CD_URSUS), 		}, 		
		[ABILITYID_CD_KRAGLEN]  			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.KRAGLEN,		id = 14, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_KRAGLEN), 		}, 
		[ABILITYID_KRAGLEN]  				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.KRAGLEN,		id = 14, bFilterSource = false,	bSetCD = true, cd = GetAbilityDuration(ABILITYID_CD_KRAGLEN), 		}, 		
		[ABILITYID_CD_SANGUINE]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LADYTHORN,		id = 15, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SANGUINE), 	}, 
		[ABILITYID_SANGUINE]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LADYTHORN,		id = 15, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_SANGUINE), 		}, 		
		[ABILITYID_CD_GPREPRISAL]			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GPREPRISAL,	id = 16, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_GPREPRISAL), 	}, 
		[ABILITYID_GPREPRISAL]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GPREPRISAL,	id = 16, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_GPREPRISAL), 		}, 
		-- Portal synergies
		[ABILITYID_CD_VCRPORTAL]			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CR_PRTAL,		id = 19, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_VCRPORTAL), 	},
		[ABILITYID_CD_DSR_REEF]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.DSR_REEF,		id = 20, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_DSR_REEF), 	},			
		[ABILITYID_CD_SE_AGONY]				= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SE_PORTAL,		id = 21, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SE_AGONY), 	},	
		[ABILITYID_CD_SE_VANTO_CLARITY]		= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SE_PORTAL,		id = 21, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SE_VANTO_CLARITY), },
		[ABILITYID_CD_LC_MIRROR]			= { enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LC_MIRROR,		id = 22, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_LC_MIRROR), 	},
	}
	TSG_LIST = {
		[1] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BLOODALTAR, 	icon = ICON_UNDAUNTED_ALTAR_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[2] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS, 	icon = ICON_UNDAUNTED_WEBS_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[3] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BONESHIELD,	icon = ICON_UNDAUNTED_BONE_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[4] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS,	icon = ICON_UNDAUNTED_ORB_2,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[5] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PURIFY,		icon = ICON_TEMPLAR_RITUAL_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[6] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CONDUIT,		icon = ICON_SORC_CONDUIT_0,		bSetCD = false, cdset = 0, cdsyn = 0, },
		[7] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.ATRONACH,	icon = ICON_SORC_ATRO_0,		bSetCD = false, cdset = 0, cdsyn = 0, },
		[8] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHACKLE,		icon = ICON_DK_CLAW_0,			bSetCD = false, cdset = 0, cdsyn = 0, },
		[9] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HARVEST,		icon = ICON_WARDEN_HARVEST_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
		[10] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GRAVEROBBER,	icon = ICON_NECRO_GRAVE_0,		bSetCD = false, cdset = 0, cdsyn = 0, },
		[11] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PUREAGONY,	icon = ICON_NECRO_TOTEM_0,		bSetCD = false, cdset = 0, cdsyn = 0, },
		[12] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HOWLING,		icon = ICON_WOLF,				bSetCD = false, cdset = 0, cdsyn = 0, },
		[13] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.URSUS,		icon = ICON_ITEM_URSUS,			bSetCD = true, cdset = 0, cdsyn = 0, },
		[14] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.KRAGLEN,		icon = ICON_ITEM_KRAGLEN,		bSetCD = true, cdset = 0, cdsyn = 0, },
		[15] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LADYTHORN,	icon = ICON_ITEM_SANGUINE,		bSetCD = true, cdset = 0, cdsyn = 0, },
		[16] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GPREPRISAL,	icon = ICON_ITEM_GPREPRISAL,	bSetCD = true, cdset = 0, cdsyn = 0, },
		[17] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.RUNE,		icon = ICON_ARCANIST_RUNE,		bSetCD = false, cdset = 0, cdsyn = 0, },
		[18] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PORTAL,		icon = ICON_ARCANIST_PORTAL,	bSetCD = false, cdset = 0, cdsyn = 0, },	
		[19] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CR_PRTAL,	icon = ICON_VCR_GATE,			bSetCD = false, cdset = 0, cdsyn = 0, },	
		[20] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.DSR_REEF,	icon = ICON_DSR_DINFESTATION,	bSetCD = false, cdset = 0, cdsyn = 0, },	
		[21] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SE_PORTAL,	icon = ICON_SE_AGONY,			bSetCD = false, cdset = 0, cdsyn = 0, },		
		[22] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LC_MIRROR,	icon = ICON_LC_MIRROR,			bSetCD = false, cdset = 0, cdsyn = 0, },
		[23] = 	{ enable = BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.INNERFIRE,	icon = ICON_UNDAUNTED_FIRE_0,	bSetCD = false, cdset = 0, cdsyn = 0, },
	}		
end
local function OnCombatEvent( _, result, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log, sourceUnitId, targetUnitId, abilityId, overflow )
	if result == ACTION_RESULT_EFFECT_GAINED then -- 2240
		if SYNERGYLIST[abilityId] ~= nil and SYNERGYLIST[abilityId].enable == true then 					
			local unitTag = "Offline"
			if GROUP_UNITID[targetUnitId] ~= nil then unitTag = GROUP_UNITID[targetUnitId] end			
			if GROUP_INFO[unitTag] ~= nil then 
				GROUP_INFO[unitTag].cdList[SYNERGYLIST[abilityId].id].cd = (GetGameTimeMilliseconds()/1000) + (SYNERGYLIST[abilityId].cd/1000)
				GROUP_INFO[unitTag].cdList[SYNERGYLIST[abilityId].id].start = (GetGameTimeMilliseconds()/1000)
			end	
		end
	end	
end
local function GTrackUpdateCooldown()
	for ListId in pairs(TSG_LIST) do
		if TSG_LIST[ListId].enable then
			for GRI = 1, GetGroupSize() do
				local unitTag = GetGroupUnitTagByIndex(GRI)	
				if unitTag == nil or unitTag == "nil" then return end								
				local DURATION = GROUP_INFO[unitTag].cdList[ListId].cd - (GetGameTimeMilliseconds()/1000)									
				local UI_FILL = 120
				local BG_R = 255
				local BG_G = 0				
				if DURATION > 0 then 
					UI_FILL = DURATION/(GROUP_INFO[unitTag].cdList[ListId].cd-GROUP_INFO[unitTag].cdList[ListId].start) * 120
					if UI_FILL < 0 then UI_FILL = 0 end
					BG_R = (UI_FILL > (120 / 2) and (UI_FILL *2/(120 / 4))) or 1
					BG_G = (UI_FILL < (120 / 2) and (UI_FILL *2/(120 / 3))) or 1
					BSCAS.frames[ListId].panels[GRI].cd:SetText(string.format("%.1f", DURATION))
				else
					BSCAS.frames[ListId].panels[GRI].cd:SetText(string.format("%.1f", 0))
				end				
				BSCAS.frames[ListId].panels[GRI].fill:SetWidth(UI_FILL)
				BSCAS.frames[ListId].panels[GRI].fill:SetCenterColor(BG_R, BG_G, 0, 0.60)				
			end
		end
	end	
end
function BSCAS.GTrackUpdateSetting()
	UpdateEnabled()
	local groupS = GetGroupSize() 
	-- update visible UI
	local oldpan = nil
	for ListId in pairs(TSG_LIST) do
		-- first hide all
		BSCAS.frames[ListId].frame:SetHidden(true)
		local index = 1
		for GRI = 1, BSC_GROUP_SIZE_MAX do
			BSCAS.frames[ListId].panels[GRI].panel:SetHidden(true)
			BSCAS.frames[ListId].panels[GRI].panel:ClearAnchors()
			if index == 1 then
				BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, BSCAS.frames[ListId].frame, TOPLEFT, 0, 0)
			else
				BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, oldpan, BOTTOMLEFT, 0, 0)
			end
			oldpan = BSCAS.frames[ListId].panels[GRI].panel
			index = index + 1	
		end		
		if TSG_LIST[ListId].enable and groupS > 1 and BSCAS.SV.GROUP_TRACKING_ENABLED then
			BSCAS.frames[ListId].frame:SetHidden(false)
			index = 1
			for GRI = 1, BSC_GROUP_SIZE_MAX do
				if groupS >= GRI then
					local unitTag = GetGroupUnitTagByIndex(GRI)
					if unitTag ~= GetLocalPlayerGroupUnitTag() and IsUnitPlayer(unitTag) then	
						if IsUnitOnline(unitTag) then
							local role = GetGroupMemberSelectedRole(unitTag)
							if role == LFG_ROLE_TANK and BSCAS.SV.GROUP_TRACKING_TANK 
							or role == LFG_ROLE_HEAL and BSCAS.SV.GROUP_TRACKING_HEAL 
							or role == LFG_ROLE_DPS and BSCAS.SV.GROUP_TRACKING_DPS then								
								BSCAS.frames[ListId].panels[GRI].panel:ClearAnchors()
								if index == 1 then
									BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, BSCAS.frames[ListId].frame, TOPLEFT, 0, 0)
								else
									BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, oldpan, BOTTOMLEFT, 0, 0)
								end
								oldpan = BSCAS.frames[ListId].panels[GRI].panel
								index = index + 1									
								BSCAS.frames[ListId].panels[GRI].name:SetText(GetUnitDisplayName(unitTag))	
								local rtexture = "/esoui/art/lfg/lfg_icon_dps.dds"
								if role == LFG_ROLE_TANK then
									rtexture = "/esoui/art/lfg/lfg_icon_tank.dds"
								elseif role == LFG_ROLE_HEAL then 
									rtexture = "/esoui/art/lfg/lfg_icon_healer.dds"
								end	
								BSCAS.frames[ListId].panels[GRI].role:SetTexture(rtexture)						
								if IsUnitInGroupSupportRange(unitTag) then
									BSCAS.frames[ListId].panels[GRI].panel:SetAlpha(1)
								else
									BSCAS.frames[ListId].panels[GRI].panel:SetAlpha(0.5)
								end
								BSCAS.frames[ListId].panels[GRI].panel:SetHidden(false)	
							else
								BSCAS.frames[ListId].panels[GRI].panel:SetHidden(true)	
							end
						end
					end
				else
					BSCAS.frames[ListId].panels[GRI].panel:SetHidden(true)
				end
			end			
			SCENE_MANAGER:GetScene("hud"):AddFragment(BSCAS.fragments[ListId])
			SCENE_MANAGER:GetScene("hudui"):AddFragment(BSCAS.fragments[ListId])				
		else		
			SCENE_MANAGER:GetScene("hud"):RemoveFragment(BSCAS.fragments[ListId])
			SCENE_MANAGER:GetScene("hudui"):RemoveFragment(BSCAS.fragments[ListId])
		end
	end	
end
function BSCAS.OnMoveStopGT(ListId, frame)
	if BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId] == nil then BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId] = { } end
	BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId].left = frame:GetLeft()
	BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId].top = frame:GetTop()
end
local function CreateUI()	
	local WM = GetWindowManager()
	BSCAS.frames = { }	
	BSCAS.fragments = { }
	for ListId in pairs(TSG_LIST) do
		local frame = WM:CreateControlFromVirtual("BSCASynergyGTUIF" .. ListId, nil, "BSCASynergyGTUIF")
		frame:SetHandler("OnMoveStop", function() BSCASynergy.OnMoveStopGT(ListId, frame) end)		
		frame:GetNamedChild("Icon"):SetTexture(TSG_LIST[ListId].icon)	
		BSCAS.frames[ListId] = {
			frame = frame,
			panels = {},
		}		
		local oldpan = nil
		for GRI = 1, BSC_GROUP_SIZE_MAX do
			local panel = WM:CreateControlFromVirtual("BSCASynergyGTUIP" .. ListId .. "_" .. GRI, frame, "BSCASynergyGTUIP")						
			BSCAS.frames[ListId].panels[GRI] = {
				panel = panel,
				bg = panel:GetNamedChild("Backdrop"),
				role = panel:GetNamedChild("Role"),
				name = panel:GetNamedChild("Name"),
				cd = panel:GetNamedChild("Cooldown"),
				fill = panel:GetNamedChild("Fill")
			}
			BSCAS.frames[ListId].panels[GRI].bg:SetEdgeColor(0, 0, 0, 0)
			BSCAS.frames[ListId].panels[GRI].bg:SetCenterColor(0, 0, 0, 0.5)
			BSCAS.frames[ListId].panels[GRI].cd:SetColor(1, 1, 1, 1)
			BSCAS.frames[ListId].panels[GRI].cd:SetText("0")	
			BSCAS.frames[ListId].panels[GRI].fill:SetCenterColor(255, 0, 0, 0.40)			
			if GRI == 1 then
				BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, frame, TOPLEFT, 0, 0)
			else
				BSCAS.frames[ListId].panels[GRI].panel:SetAnchor(TOPLEFT, oldpan, BOTTOMLEFT, 0, 0)
			end
			oldpan = panel
		end
		frame:ClearAnchors()
		if BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId] == nil then
			frame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 200, 200)
		else
			frame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId].left, BSCAS.SV.GROUP_TRACKING_UI_POSITION[ListId].top)
		end		
		BSCAS.fragments[ListId] = ZO_HUDFadeSceneFragment:New(frame)
	end
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- //////////////////////////////////////////////// --- Group -- /////////////////////////////////////////////////////
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local bUpdateGroupAfterCombat = false
local function GroupUpdate()	
	if IsUnitInCombat("player") then 
		bUpdateGroupAfterCombat = true
		return 
	end
	BSCAS.GTrackUpdateSetting()
	bUpdateGroupAfterCombat = false
end
local function GroupRoleChange(unitTag, assignedRole)	
	BSCAS.GTrackUpdateSetting()
end
function BSCAS:CallUpdateAfterCombatTG()
	if bUpdateGroupAfterCombat then GroupUpdate() end
end
local function GroupRangeUpdate(unitTag, status)	
	if not IsUnitPlayer(unitTag) then return end
	local GRI = GetGroupIndexByUnitTag(unitTag) 
	for ListId in pairs(TSG_LIST) do
		if TSG_LIST[ListId].enable then
			if BSCAS.frames[ListId] ~= nil then
				if BSCAS.frames[ListId].panels[GRI] ~= nil then
					if status then
						BSCAS.frames[ListId].panels[GRI].panel:SetAlpha(1)
					else
						BSCAS.frames[ListId].panels[GRI].panel:SetAlpha(0.5)
					end
				end
			end
		end
	end	
end
local function OnEffectChanged(_, _, _, _, unitTag, _, _, _, _, _, _, _, _, unitName, unitId, _, _)
	if not IsUnitPlayer(unitTag) then return end
	if GROUP_INFO[unitTag] ~= nil then 
		GROUP_INFO[unitTag].unitId = unitId
		GROUP_UNITID[unitId] = unitTag
	end
end
local function GroupInit()
	GROUP_UNITID = { }
	for i = 1, BSC_GROUP_SIZE_MAX do
		local unitTag = "group"..i
		GROUP_INFO[unitTag] = { }
		GROUP_INFO[unitTag].unitId = -1
		GROUP_INFO[unitTag].cdList = { }
		for ListId in pairs(TSG_LIST) do
			GROUP_INFO[unitTag].cdList[ListId] = { }
			GROUP_INFO[unitTag].cdList[ListId].cd = 0
			GROUP_INFO[unitTag].cdList[ListId].start = 0
		end
	end	
end
function BSCAS.GroupTrackEnable()
	if BSCAS.SV.GROUP_TRACKING_ENABLED then 		
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_GRTROEC'..abilityId
			EVENT_MANAGER:RegisterForEvent(eventName, EVENT_COMBAT_EVENT, OnCombatEvent)
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, abilityId)					
			if SYNERGYLIST[abilityId].bFilterSource then 
				EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_NONE)
			else			
				EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_NONE)		
			end	
		end				
		EVENT_MANAGER:RegisterForUpdate('BSCAS_GroupTrackUpdate', BSCAS.UPDATE_INTERVAL, GTrackUpdateCooldown)		
		local eventName = 'BSCAS_GRTROEC'
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_MEMBER_JOINED, function(...) zo_callLater(function() GroupUpdate() end, 1500) end) 
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_MEMBER_LEFT, function(...) zo_callLater(function() GroupUpdate() end, 1500) end)	
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_MEMBER_ROLE_CHANGED, function(eventCode, unitTag, assignedRole) GroupRoleChange(unitTag, assignedRole) end)	
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_SUPPORT_RANGE_UPDATE, function(eventCode, unitTag, status) GroupRangeUpdate(unitTag, status) end)			
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_EFFECT_CHANGED, OnEffectChanged)
		EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG_PREFIX, "group")		
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_PLAYER_ACTIVATED, function(...) zo_callLater(function() GroupUpdate() end, 1500) end)
	else	
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_GRTROEC'..abilityId
			EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_COMBAT_EVENT)
		end
		EVENT_MANAGER:UnregisterForUpdate('BSCAS_GroupTrackUpdate')		
		local eventName = 'BSCAS_GRTROEC'
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_MEMBER_JOINED)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_MEMBER_LEFT)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_MEMBER_ROLE_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_SUPPORT_RANGE_UPDATE)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_EFFECT_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_PLAYER_ACTIVATED)
	end	
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- //////////////////////////////////////////////// --- Init -- //////////////////////////////////////////////////////
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCAS.GroupTrackInit()
	UpdateEnabled()
	GroupInit()	
	CreateUI()
	--
	BSCAS.InitGroupTrackingMenu()		
	BSCAS.GroupTrackEnable()	
end
