BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

--BSCAS.SV 
local defaultSV = {	
	PVP_AREA_ENABLED = false,
	ADD_WW_PLUGIN = false,
	SELECTED_PRESET = "Default",
	SELECTED_PRESET_TANK = "Default",
	SELECTED_PRESET_HEAL = "Default",
	SELECTED_PRESET_DPS = "Default",
	-- Alkosh UI
	ALKOSH_CHECK = false,
	ALKOSH_CHECK_AUTO = false,
	ALKOSH_SOUND_PLAY = false,
	ALKOSH_SOUND_INC = 2,
	ALKOSH_SOUND_ID = "Voice_Chat_Alert_Channel_Made_Active",
	ALKOSH_SOUND_LOOP = 1,
	ALKOSH_FONT_SIZE = 16,
	ALKOSH_LIST_COUNT = 10,
	ALKOSH_ENABLE_MARK = true,
	ALKOSH_LOCK_UI = false,
	ALKOSH_PRINT_CHAT = true,
	ALKOSH_REAPPLY = 3,
	UI_LEFT = 200,
	UI_TOP  = 200,
	UI_WIDTH = 300,
	UI_HIGHT = 30,
	UI_ALPHA = 1,
	-- Slayer UI
	MSLAYER_CHECK = false,
	MSLAYER_SOUND_PLAY = false,
	MSLAYER_SOUND_INC = 2,
	MSLAYER_SOUND_ID = "Duel_Accepted", 
	MSLAYER_SOUND_LOOP = 1,
	MSLAYER_ENABLE_NAME = true,
	MSLAYER_ENABLE_ICON = true,
	MSLAYER_ENABLE_MARK = true,
	MSLAYER_FONT_SIZE = 16,
	MSLAYER_LOCK_UI = false,
	MSLAYER_ENABLE_AUTO_HIDE = false,
	UIMS_LEFT = 200,
	UIMS_TOP  = 100,
	UIMS_WIDTH = 250,
	UIMS_HIGHT = 40,
	UIMS_ALPHA = 1,
	-- Tracking UI
	TRACKING_UI_FONT = "BOLD_FONT",
	TRACKING_UI_FONT_STYLE = "soft-shadow-thick", 
	TRACKING_UI_FONT_COLOR_N = {0, 255, 0, 255},
	TRACKING_UI_FONT_COLOR_C = {255, 0, 0, 255},
	TRACKING_ENABLED = false,
	TRACKING_LOCK_UI = false,
	TRACKING_UI_ORIENT = "Vertical",
	TRACKING_UI_SIZE = 40,
	TRACKING_UI_SIZE_OUTLINE = 3,
	TRACKING_UI_LEFT = 200,
	TRACKING_UI_TOP = 400,
	TRACKING_UI_ALPHA = 1,
	TRACKING_UI_TSG_LIST = { 
		BLOODALTAR 	= true, -- undaunted
		SPIDERS		= true, -- undaunted
		INNERFIRE	= true, -- undaunted
		BONESHIELD 	= true, -- undaunted
		SHARTSORBS	= true,	-- templar + orbs
		PURIFY		= true,	-- templar
		CONDUIT 	= true, -- sorc
		ATRONACH	= true, -- sorc
		SHACKLE		= true, -- dk
		HARVEST		= true, -- Warden
		GRAVEROBBER = true, -- Necro
		PUREAGONY	= true, -- Necro
		RUNE		= true, -- Arcanist
		PORTAL 		= true, -- Arcanist
		HOWLING		= true, -- Werwolf
		KRAGLEN		= true, -- Kraglen's Howl
		LADYTHORN	= true, -- Sanguine Burst
		URSUS		= true, -- Ursus
		GPREPRISAL 	= true, -- Gryphon's Reprisa		
		CR_PRTAL 	= true, --
		DSR_REEF 	= true, -- 
		SE_PORTAL	= true, --
	},
	-- Group Tracking
	GROUP_TRACKING_ENABLED = false,
	GROUP_TRACKING_UI_TSG_LIST = { 
		BLOODALTAR 	= false, -- undaunted
		SPIDERS		= false, -- undaunted
		INNERFIRE	= false, -- undaunted
		BONESHIELD 	= false, -- undaunted
		SHARTSORBS	= false, -- templar + orbs
		PURIFY		= false, -- templar
		CONDUIT 	= false, -- sorc
		ATRONACH	= false, -- sorc
		SHACKLE		= false, -- dk
		HARVEST		= false, -- Warden
		GRAVEROBBER = false, -- Necro
		PUREAGONY	= false, -- Necro
		RUNE		= false, -- Arcanist
		PORTAL 		= false, -- Arcanist
		HOWLING		= false, -- Werwolf
		KRAGLEN		= false, -- Kraglen's Howl
		LADYTHORN	= false, -- Sanguine Burst
		URSUS		= false, -- Ursus
		GPREPRISAL 	= false, -- Gryphon's Reprisa
		CR_PRTAL 	= false, --
		DSR_REEF 	= false, -- 
		SE_PORTAL	= false, --
	},
	GROUP_TRACKING_UI_POSITION = { },
	GROUP_TRACKING_TANK = true,
	GROUP_TRACKING_HEAL = true,
	GROUP_TRACKING_DPS = true,
	-- Target Tracking
	TARGET_TRACKING_ENABLED = false,
	TARGET_TRACKING_UI_PLAYER = { },
	TARGET_TRACKING_SELECTED_PLAYER = GetUnitDisplayName('player'),--"@Default",
	TARGET_TRACKING_USEACCNAME = true,
}

--BSCAS.SV_acc
local defaultSavedVarsAccount = { 
	VERSION_ALERT = 1,
	DEBUG_LIST = {},
	SETTING = {},
	UIALERT_TOP = 0,
	UIALERT_LEFT = 0,
	UIALERT_COLOR = { 0, 0.8, 0, 0.4 },
	SHOW_USED_MEMPRY = false,
}

function BSCAS.LoadSavedData()
	-- Saved vars are needed
	BSCAS.SV = ZO_SavedVars:NewCharacterNameSettings(BSCAS.SavedVar, BSCAS.Version, nil, defaultSV)
	BSCAS.SV_acc = ZO_SavedVars:NewAccountWide(BSCAS.SavedVar, BSCAS.Version, nil, defaultSavedVarsAccount)		
end