BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local SYNERGYLIST = { }
local TSG_LIST = { }

local debug_mode = false
function BSCAS.TrackDebugMode()
	if debug_mode then
		debug_mode = false
		BSCAS:PrintDebug("Debug Mode (Tracking) Disabled!")			
	else
		debug_mode = true		
		BSCAS:PrintDebug("Debug Mode (Tracking) Enabled!")		
	end
end

-- Tracking id's
local function UpdateEnabled()
	SYNERGYLIST = { }		
	SYNERGYLIST[ABILITYID_CD_BLOOD_FUNNEL]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BLOODALTAR, 	id = 1,  bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BLOOD_FUNNEL),  	} 				
	SYNERGYLIST[ABILITYID_CD_FEAST_FUNNEL]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BLOODALTAR, 	id = 1,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_FEAST_FUNNEL),  	} 	
	SYNERGYLIST[ABILITYID_CD_SPAWNBROODLING]		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS, 	id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SPAWNBROODLING),  	}
	SYNERGYLIST[ABILITYID_CD_BLACK_WIDOW]  			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS, 	id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BLACK_WIDOW),  	}
	SYNERGYLIST[ABILITYID_CD_ARACHNOPHOBIA]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS, 	id = 2,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_ARACHNOPHOBIA),	} 	
	SYNERGYLIST[ABILITYID_CD_BONE_WALL]  			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BONESHIELD,	id = 3,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_BONE_WALL),		} 
	SYNERGYLIST[ABILITYID_CD_SPINALSURGE]  			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BONESHIELD,	id = 3,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SPINALSURGE),  	} 
	SYNERGYLIST[ABILITYID_CD_SHARTBUBLE_1]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_1),  	} 
	SYNERGYLIST[ABILITYID_CD_SHARTBUBLE_2]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_2),  	} 
	SYNERGYLIST[ABILITYID_CD_SHARTBUBLE_3]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_3),  	} 
	SYNERGYLIST[ABILITYID_CD_HEALING_COMBUSTION]	= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS,	id = 4,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_HEALING_COMBUSTION), }
	SYNERGYLIST[ABILITYID_CD_PURIFY]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PURIFY,		id = 5,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PURIFY),  			} 
	SYNERGYLIST[ABILITYID_CD_CONDUIT]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.CONDUIT,		id = 6,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_CONDUIT),  		} 
	SYNERGYLIST[ABILITYID_CD_CHARGED_LIGHTNING]  	= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.ATRONACH,	id = 7,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_CHARGED_LIGHTNING),} 
	SYNERGYLIST[ABILITYID_CD_SHACKLE]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHACKLE,		id = 8,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SHACKLE),  		}  
	SYNERGYLIST[ABILITYID_CD_IGNITE]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHACKLE,		id = 8,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_IGNITE),  			} 
	SYNERGYLIST[ABILITYID_CD_HARVEST]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.HARVEST,		id = 9,	 bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_HARVEST), 			} 
	SYNERGYLIST[ABILITYID_CD_GRAVEROBBER] 			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.GRAVEROBBER, id = 10, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_GRAVEROBBER), 		} 
	SYNERGYLIST[ABILITYID_CD_PURE_AGONY] 			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PUREAGONY,	id = 11, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PURE_AGONY), 		} 
	SYNERGYLIST[ABILITYID_CD_FEEDING_FRENZY]  		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.HOWLING,		id = 12, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_FEEDING_FRENZY), 	} 
	SYNERGYLIST[ABILITYID_CD_RUNE]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.RUNE,		id = 17, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_RUNE), 	} 
	SYNERGYLIST[ABILITYID_CD_PORTAL]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PORTAL,		id = 18, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_PORTAL), 	} 
	SYNERGYLIST[ABILITYID_CD_INNERFIRE]  			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.INNERFIRE,	id = 23, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_INNERFIRE), 	} 
	-- Set synergies
	SYNERGYLIST[ABILITYID_CD_URSUS]					= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.URSUS,		id = 13, bFilterSource = false, bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_URSUS), 	} 
	SYNERGYLIST[ABILITYID_URSUS]					= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.URSUS,		id = 13, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_CD_URSUS), 	} 		
	SYNERGYLIST[ABILITYID_CD_KRAGLEN]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.KRAGLEN,		id = 14, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_KRAGLEN), 	}
	SYNERGYLIST[ABILITYID_KRAGLEN]  				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.KRAGLEN,		id = 14, bFilterSource = false,	bSetCD = true, cd = GetAbilityDuration(ABILITYID_CD_KRAGLEN), 	} 		
	SYNERGYLIST[ABILITYID_CD_SANGUINE]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.LADYTHORN,	id = 15, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SANGUINE), } 
	SYNERGYLIST[ABILITYID_SANGUINE]					= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.LADYTHORN,	id = 15, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_SANGUINE), 	}		
	SYNERGYLIST[ABILITYID_CD_GPREPRISAL]			= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.GPREPRISAL,	id = 16, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_GPREPRISAL), } 
	SYNERGYLIST[ABILITYID_GPREPRISAL]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.GPREPRISAL,	id = 16, bFilterSource = true, 	bSetCD = true, cd = GetAbilityDuration(ABILITYID_GPREPRISAL), 	}
	-- Portal synergies
	SYNERGYLIST[ABILITYID_CD_VCRPORTAL]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.CR_PRTAL,	id = 19, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_VCRPORTAL), 	}
	SYNERGYLIST[ABILITYID_CD_DSR_REEF]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.DSR_REEF,	id = 20, bFilterSource = false,	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_DSR_REEF), 	}	
	SYNERGYLIST[ABILITYID_CD_SE_AGONY]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SE_PORTAL,	id = 21, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SE_AGONY), 	}
	SYNERGYLIST[ABILITYID_CD_SE_VANTO_CLARITY]		= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SE_PORTAL,	id = 21, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_SE_VANTO_CLARITY), 	}
	SYNERGYLIST[ABILITYID_CD_LC_MIRROR]				= { enable = BSCAS.SV.TRACKING_UI_TSG_LIST.LC_MIRROR,	id = 22, bFilterSource = true, 	bSetCD = false, cd = GetAbilityDuration(ABILITYID_CD_LC_MIRROR), 	}
	
	TSG_LIST = { }
	TSG_LIST[1] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BLOODALTAR, 	icon = ICON_UNDAUNTED_ALTAR_0,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[2] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS, 		icon = ICON_UNDAUNTED_WEBS_0,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[3] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.BONESHIELD,	icon = ICON_UNDAUNTED_BONE_0,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[4] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS,	icon = ICON_UNDAUNTED_ORB_2,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[5] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PURIFY,		icon = ICON_TEMPLAR_RITUAL_0,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[6] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.CONDUIT,		icon = ICON_SORC_CONDUIT_0,		bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[7] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.ATRONACH,		icon = ICON_SORC_ATRO_0,		bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[8] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SHACKLE,		icon = ICON_DK_CLAW_0,			bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[9] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.HARVEST,		icon = ICON_WARDEN_HARVEST_0,	bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[10] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.GRAVEROBBER,	icon = ICON_NECRO_GRAVE_0,		bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[11] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PUREAGONY,		icon = ICON_NECRO_TOTEM_0,		bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[12] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.HOWLING,		icon = ICON_WOLF,				bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[13] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.URSUS,			icon = ICON_ITEM_URSUS,			bSetCD = true, cdset = 0, cdsyn = 0, }
	TSG_LIST[14] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.KRAGLEN,		icon = ICON_ITEM_KRAGLEN,		bSetCD = true, cdset = 0, cdsyn = 0, }
	TSG_LIST[15] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.LADYTHORN,		icon = ICON_ITEM_SANGUINE,		bSetCD = true, cdset = 0, cdsyn = 0, }
	TSG_LIST[16] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.GPREPRISAL,	icon = ICON_ITEM_GPREPRISAL,	bSetCD = true, cdset = 0, cdsyn = 0, }	
	TSG_LIST[17] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.RUNE,			icon = ICON_ARCANIST_RUNE,		bSetCD = false, cdset = 0, cdsyn = 0, }
	TSG_LIST[18] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.PORTAL,		icon = ICON_ARCANIST_PORTAL,	bSetCD = false, cdset = 0, cdsyn = 0, }	
	TSG_LIST[19] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.CR_PRTAL,		icon = ICON_VCR_GATE,			bSetCD = false, cdset = 0, cdsyn = 0, }	
	TSG_LIST[20] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.DSR_REEF,		icon = ICON_DSR_DINFESTATION,	bSetCD = false, cdset = 0, cdsyn = 0, }	
	TSG_LIST[21] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.SE_PORTAL,		icon = ICON_SE_AGONY,			bSetCD = false, cdset = 0, cdsyn = 0, }		
	TSG_LIST[22] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.LC_MIRROR,		icon = ICON_LC_MIRROR,			bSetCD = false, cdset = 0, cdsyn = 0, }	
	TSG_LIST[23] = 	{ enable = BSCAS.SV.TRACKING_UI_TSG_LIST.INNERFIRE,		icon = ICON_UNDAUNTED_FIRE_0,	bSetCD = false, cdset = 0, cdsyn = 0, }		
end
  
local function CreateControls()
	for i, _ in ipairs(TSG_LIST) do
		WINDOW_MANAGER:CreateControlFromVirtual("$(parent)Cooldown", BSCASTackingUI, "BSCASTackingCD", i)
		BSCASTackingUI:GetNamedChild("Cooldown" .. i .. "Icon"):SetTexture(TSG_LIST[i].icon)
	end
end
local function UpdateBackGround(counter)
	local outline = BSCAS.SV.TRACKING_UI_SIZE_OUTLINE --math.floor(BSCAS.SV.TRACKING_UI_SIZE / 10)
	if counter > 0 and BSCAS.SV.TRACKING_UI_ORIENT == "Horizontal" then
		BSCASTackingUI:GetNamedChild("Texture"):SetHidden(false)
		BSCASTackingUI:GetNamedChild("Texture"):SetDimensions(counter * (BSCAS.SV.TRACKING_UI_SIZE + outline) + outline, BSCAS.SV.TRACKING_UI_SIZE + 2 * outline)
	elseif counter > 0 and BSCAS.SV.TRACKING_UI_ORIENT == "Vertical" then
		BSCASTackingUI:GetNamedChild("Texture"):SetHidden(false)
		BSCASTackingUI:GetNamedChild("Texture"):SetDimensions(BSCAS.SV.TRACKING_UI_SIZE + 2 * outline, counter * (BSCAS.SV.TRACKING_UI_SIZE + outline) + outline)
	else BSCASTackingUI:GetNamedChild("Texture"):SetHidden(true) end
end

local function UpdateIconSize()
	local cdControl = nil
	for i, _ in ipairs(TSG_LIST) do
		cdControl = BSCASTackingUI:GetNamedChild("Cooldown" .. i)
		
		local icon = cdControl:GetNamedChild("Icon")		
		icon:SetDimensions(BSCAS.SV.TRACKING_UI_SIZE, BSCAS.SV.TRACKING_UI_SIZE)
		
		local fnt_size = math.floor(BSCAS.SV.TRACKING_UI_SIZE * 0.6) 
		local fnt_size_2 = math.floor(BSCAS.SV.TRACKING_UI_SIZE * 0.4)
		
		if TSG_LIST[i].bSetCD then
			cdControl:GetNamedChild("SynCD"):SetFont("$("..BSCAS.SV.TRACKING_UI_FONT..")|$(KB_" .. BSCAS.FontCheck(fnt_size)  .. ")|"..BSCAS.SV.TRACKING_UI_FONT_STYLE)
			cdControl:GetNamedChild("SetCD"):SetFont("$(MEDIUM_FONT)|$(KB_" .. BSCAS.FontCheck(fnt_size_2) .. ")|"..BSCAS.SV.TRACKING_UI_FONT_STYLE)	
			cdControl:GetNamedChild("SynCD"):ClearAnchors()
			cdControl:GetNamedChild("SynCD"):SetAnchor(CENTER, 	icon, CENTER, 0, ((fnt_size_2 / 2) * -1))
			cdControl:GetNamedChild("SetCD"):ClearAnchors()
			cdControl:GetNamedChild("SetCD"):SetAnchor(CENTER, 	icon, CENTER, 0, (fnt_size_2 / 2))	
			cdControl:GetNamedChild("SynCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_N))			

			BSCASTackingUI:GetNamedChild("Cooldown" .. i .. "SetCD"):SetHidden(false)			
		else
			cdControl:GetNamedChild("SynCD"):SetFont("$("..BSCAS.SV.TRACKING_UI_FONT..")|$(KB_" .. BSCAS.FontCheck(fnt_size) .. ")|"..BSCAS.SV.TRACKING_UI_FONT_STYLE)
			cdControl:GetNamedChild("SynCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_N))	
			BSCASTackingUI:GetNamedChild("Cooldown" .. i .. "SetCD"):SetHidden(true)
		end
	end
end

function BSCAS.TrackUpdateUI()
	UpdateEnabled()
	local counter = 0
	local cdControl = nil
	for i, v in ipairs(TSG_LIST) do
		cdControl = BSCASTackingUI:GetNamedChild("Cooldown" .. i)
		
		local outline = BSCAS.SV.TRACKING_UI_SIZE_OUTLINE --math.floor(BSCAS.SV.TRACKING_UI_SIZE / 10)
		
		if v.enable and BSCAS.SV.TRACKING_UI_ORIENT == "Horizontal" then
			cdControl:SetHidden(false)
			cdControl:ClearAnchors()
			cdControl:SetAnchor(TOPLEFT, BSCASTackingUI, TOPLEFT, outline + counter * (BSCAS.SV.TRACKING_UI_SIZE + outline), outline)
			counter = counter + 1
		elseif v.enable and BSCAS.SV.TRACKING_UI_ORIENT == "Vertical" then
			cdControl:SetHidden(false)
			cdControl:ClearAnchors()
			cdControl:SetAnchor(TOPLEFT, BSCASTackingUI, TOPLEFT, outline, outline + counter * (BSCAS.SV.TRACKING_UI_SIZE + outline))
			counter = counter + 1
		else 
			cdControl:SetHidden(true) 
		end
	end	
	BSCASTackingUI:SetAlpha(BSCAS.SV.TRACKING_UI_ALPHA)	
	UpdateBackGround(counter)
	UpdateIconSize()
end

local function ToggleUI(oldState, newState)
	if not BSCAS.SV.TRACKING_ENABLED then return end

	if newState == SCENE_SHOWN then
		BSCASTackingUI:SetHidden(false)
	elseif newState == SCENE_HIDDEN then
		BSCASTackingUI:SetHidden(true)
	end
end
function BSCAS.TrackOnMoveStop()
	BSCAS.SV.TRACKING_UI_LEFT = BSCASTackingUI:GetLeft()
	BSCAS.SV.TRACKING_UI_TOP = BSCASTackingUI:GetTop()
end

local function RestorePosition()
	BSCASTackingUI:ClearAnchors()
	BSCASTackingUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCAS.SV.TRACKING_UI_LEFT, BSCAS.SV.TRACKING_UI_TOP)
	BSCASTackingUI:SetMovable(not BSCAS.SV.TRACKING_LOCK_UI)
end

local function OnCombatEvent(_, result, _, _, _, _, _, _, targetName, _, hitValue, _, _, _, _, targetUnitId, abilityId, _)		
	--if targetType ~= COMBAT_UNIT_TYPE_PLAYER or ActionSlotType ~= ACTION_TYPE_NOTHING or damageType ~= DAMAGE_TYPE_GENERIC then return end	
	if result == ACTION_RESULT_EFFECT_GAINED then -- 2240
		if SYNERGYLIST[abilityId] ~= nil and SYNERGYLIST[abilityId].enable == true then 
		
			if SYNERGYLIST[abilityId].bSetCD then
				TSG_LIST[SYNERGYLIST[abilityId].id].cdset = (GetGameTimeMilliseconds()/1000) + (SYNERGYLIST[abilityId].cd/1000)
			else
				TSG_LIST[SYNERGYLIST[abilityId].id].cdsyn = (GetGameTimeMilliseconds()/1000) + (SYNERGYLIST[abilityId].cd/1000) --+ 20
			end
			
			if debug_mode then
				BSCAS:PrintDebug(zo_strformat("GAINED Known ID[<<1>>] Name[<<2>>] Duration[<<3>>]", abilityId, GetAbilityName(abilityId), GetAbilityDuration(abilityId)))
			end
		else
			if debug_mode and GetAbilityDuration(abilityId) >= 10000 then
				BSCAS:PrintDebug(zo_strformat("GAINED Unknown ID[<<1>>] Name[<<2>>] Duration[<<3>>]", abilityId, GetAbilityName(abilityId), GetAbilityDuration(abilityId)))
			end
		end
	end	
	if result == ACTION_RESULT_EFFECT_FADED then -- 2250
		if debug_mode then 
			BSCAS:PrintDebug(zo_strformat("FADED ID[<<1>>] Name[<<2>>]", abilityId, GetAbilityName(abilityId))) 
		end
	end	
end

local function TrackUpdateCooldown()	
	local cdControl = nil	
	for idx, val in ipairs(TSG_LIST) do
		cdControl = BSCASTackingUI:GetNamedChild("Cooldown" .. idx)
		if val.enable and (val.cdsyn > 0 or val.cdset > 0) then			
			local DURATION = val.cdsyn - (GetGameTimeMilliseconds()/1000)			
			if DURATION <= 0 then 
				DURATION = 0 
				cdControl:GetNamedChild("Icon"):SetDimensions(BSCAS.SV.TRACKING_UI_SIZE, BSCAS.SV.TRACKING_UI_SIZE)
				cdControl:GetNamedChild("Icon"):SetColor(1, 1, 1, 1)			
				cdControl:GetNamedChild("SynCD"):SetText(string.format("%.1f", DURATION))
				cdControl:GetNamedChild("SynCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_N))	
				val.cdsyn = 0
			else
				cdControl:GetNamedChild("Icon"):SetDimensions(BSCAS.SV.TRACKING_UI_SIZE, BSCAS.SV.TRACKING_UI_SIZE)
				cdControl:GetNamedChild("Icon"):SetColor(0.2, 0.2, 0.2, 1)			
				cdControl:GetNamedChild("SynCD"):SetText(string.format("%.1f", DURATION))
				cdControl:GetNamedChild("SynCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_C))
			end	
			
			local DUR_SET = val.cdset - (GetGameTimeMilliseconds()/1000)
			if DUR_SET <= 0 then 
				DUR_SET = 0 
				cdControl:GetNamedChild("SetCD"):SetText(string.format("%.1f", DUR_SET))
				cdControl:GetNamedChild("SetCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_N))			
				val.cdset = 0
			else
				cdControl:GetNamedChild("SetCD"):SetText(string.format("%.1f", DUR_SET))
				cdControl:GetNamedChild("SetCD"):SetColor(unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_C))
			end
		end		
	end
end

function BSCAS.TrackEnable()
	if BSCAS.SV.TRACKING_ENABLED then 		
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_TROEC'..abilityId
			EVENT_MANAGER:RegisterForEvent(eventName, EVENT_COMBAT_EVENT, OnCombatEvent)
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, abilityId)		
			
			if SYNERGYLIST[abilityId].bFilterSource then -- Special ID's (Area Effeckt)
				EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
			else			
				EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)		
			end
		end
				
		EVENT_MANAGER:RegisterForUpdate('BSCAS_TrackUpdate', BSCAS.UPDATE_INTERVAL, TrackUpdateCooldown)
	else	
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_TROEC'..abilityId
			EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_COMBAT_EVENT)
		end
		EVENT_MANAGER:UnregisterForUpdate('BSCAS_TrackUpdate')
	end	
end

function BSCAS.TrackInit()
	UpdateEnabled()
	-- init menu
	BSCAS.InitTrackingMenu()		
	-- creationg ui stuff
	CreateControls()
	RestorePosition()
	BSCAS.TrackUpdateUI()
	
	SCENE_MANAGER:GetScene("hud"):RegisterCallback("StateChange", ToggleUI)
	SCENE_MANAGER:GetScene("hudui"):RegisterCallback("StateChange", ToggleUI)
	--
	if BSCAS.SV.TRACKING_ENABLED then BSCASTackingUI:SetHidden(false) else BSCASTackingUI:SetHidden(true) end
	
	BSCAS.TrackEnable()	
end

