BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local BSC_GROUP_SIZE_MAX = 12
local SYNERGYLIST = { }
local GROUP_INFO = { }
local GROUP_UNITID = { }

local debug_mode = false
function BSCAS.TrackTargetDebugMode()
	if debug_mode then
		debug_mode = false
		BSCAS:PrintDebug("Debug Mode (TTracking) Disabled!")			
	else
		debug_mode = true		
		BSCAS:PrintDebug("Debug Mode (TTracking) Enabled!")		
	end
end
-- Tracking id's
local SYNGERY_COUNT = 12
local function CreateSynergylist()
	SYNERGYLIST = { 
		[ABILITYID_CD_BLOOD_FUNNEL]  		= { id = 1,  cd = GetAbilityDuration(ABILITYID_CD_BLOOD_FUNNEL),  		}, 				
		[ABILITYID_CD_FEAST_FUNNEL]  		= { id = 1,	 cd = GetAbilityDuration(ABILITYID_CD_FEAST_FUNNEL),  		}, 	
		[ABILITYID_CD_SPAWNBROODLING]		= { id = 2,	 cd = GetAbilityDuration(ABILITYID_CD_SPAWNBROODLING),  	},
		[ABILITYID_CD_BLACK_WIDOW]  		= { id = 2,	 cd = GetAbilityDuration(ABILITYID_CD_BLACK_WIDOW),  		}, 	
		[ABILITYID_CD_ARACHNOPHOBIA]  		= { id = 2,	 cd = GetAbilityDuration(ABILITYID_CD_ARACHNOPHOBIA),		}, 	
		[ABILITYID_CD_BONE_WALL]  			= { id = 3,	 cd = GetAbilityDuration(ABILITYID_CD_BONE_WALL),			}, 
		[ABILITYID_CD_SPINALSURGE]  		= { id = 3,	 cd = GetAbilityDuration(ABILITYID_CD_SPINALSURGE),  		}, 
		[ABILITYID_CD_SHARTBUBLE_1]  		= { id = 4,	 cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_1),  		}, 
		[ABILITYID_CD_SHARTBUBLE_2]  		= { id = 4,	 cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_2),  		}, 
		[ABILITYID_CD_SHARTBUBLE_3]  		= { id = 4,	 cd = GetAbilityDuration(ABILITYID_CD_SHARTBUBLE_3),  		}, 
		[ABILITYID_CD_HEALING_COMBUSTION]	= { id = 4,	 cd = GetAbilityDuration(ABILITYID_CD_HEALING_COMBUSTION), 	},
		[ABILITYID_CD_PURIFY]  				= { id = 5,	 cd = GetAbilityDuration(ABILITYID_CD_PURIFY),  			}, 
		[ABILITYID_CD_CONDUIT]  			= { id = 6,	 cd = GetAbilityDuration(ABILITYID_CD_CONDUIT),  			}, 
		[ABILITYID_CD_CHARGED_LIGHTNING]  	= { id = 7,	 cd = GetAbilityDuration(ABILITYID_CD_CHARGED_LIGHTNING),	}, 
		[ABILITYID_CD_SHACKLE]  			= { id = 8,	 cd = GetAbilityDuration(ABILITYID_CD_SHACKLE),  			},  
		[ABILITYID_CD_IGNITE]  				= { id = 8,	 cd = GetAbilityDuration(ABILITYID_CD_IGNITE),  			}, 
		[ABILITYID_CD_HARVEST]  			= { id = 9,	 cd = GetAbilityDuration(ABILITYID_CD_HARVEST), 			}, 
		[ABILITYID_CD_GRAVEROBBER] 			= { id = 10, cd = GetAbilityDuration(ABILITYID_CD_GRAVEROBBER), 		}, 
		[ABILITYID_CD_PURE_AGONY] 			= { id = 11, cd = GetAbilityDuration(ABILITYID_CD_PURE_AGONY), 			},
		[ABILITYID_CD_RUNE]  				= { id = 12, cd = GetAbilityDuration(ABILITYID_CD_RUNE), 				}, 
		[ABILITYID_CD_INNERFIRE]  			= { id = 13, cd = GetAbilityDuration(ABILITYID_CD_INNERFIRE), 				},
	}	
end
local function GetInfoForUpdateSettings(playername)
	local SELECTED_NAME = BSCAS.SV.TARGET_TRACKING_UI_PLAYER[playername]
	local INFO_LIST = { }
	INFO_LIST = {
		[1] = 	{ enable = SELECTED_NAME.BLOODALTAR, 	icon = ICON_UNDAUNTED_ALTAR_0, 	name = GetString(SI_SYNERGY_NAME_BLOODALTAR), 	},
		[2] = 	{ enable = SELECTED_NAME.SPIDERS, 		icon = ICON_UNDAUNTED_WEBS_0,  	name = GetString(SI_SYNERGY_NAME_WEBS),			},
		[3] = 	{ enable = SELECTED_NAME.BONESHIELD,	icon = ICON_UNDAUNTED_BONE_0,  	name = GetString(SI_SYNERGY_NAME_BONE),			},
		[4] = 	{ enable = SELECTED_NAME.SHARTSORBS,	icon = ICON_UNDAUNTED_ORB_2,   	name = GetString(SI_SYNERGY_NAME_ORB),			},
		[5] = 	{ enable = SELECTED_NAME.PURIFY,		icon = ICON_TEMPLAR_RITUAL_0,	name = GetString(SI_SYNERGY_NAME_PURGE),		},
		[6] = 	{ enable = SELECTED_NAME.CONDUIT,		icon = ICON_SORC_CONDUIT_0,		name = GetString(SI_SYNERGY_NAME_CONDUIT),		},
		[7] = 	{ enable = SELECTED_NAME.ATRONACH,		icon = ICON_SORC_ATRO_0,		name = GetString(SI_SYNERGY_NAME_ATRO),			},
		[8] = 	{ enable = SELECTED_NAME.SHACKLE,		icon = ICON_DK_CLAW_0,			name = GetString(SI_SYNERGY_NAME_IMPALE),		},
		[9] = 	{ enable = SELECTED_NAME.HARVEST,		icon = ICON_WARDEN_HARVEST_0,	name = GetString(SI_SYNERGY_NAME_HARVEST),		},
		[10] = 	{ enable = SELECTED_NAME.GRAVEROBBER,	icon = ICON_NECRO_GRAVE_0,		name = GetString(SI_SYNERGY_NAME_BONEYARD),		},
		[11] = 	{ enable = SELECTED_NAME.PUREAGONY,		icon = ICON_NECRO_TOTEM_0,		name = GetString(SI_SYNERGY_NAME_TOTEM),		},
		[12] = 	{ enable = SELECTED_NAME.RUNE,			icon = ICON_ARCANIST_RUNE,		name = GetString(SI_SYNERGY_NAME_RUNE),			},
		[13] = 	{ enable = SELECTED_NAME.INNERFIRE,		icon = ICON_UNDAUNTED_FIRE_0,	name = GetString(SI_SYNERGY_NAME_INNERFIRE),	},
	}	
	return INFO_LIST
end
local function BSCGetUnitName(unitTag)
	if BSCAS.SV.TARGET_TRACKING_USEACCNAME then
		return tostring(zo_strformat("<<1>>", GetUnitDisplayName(unitTag))) -- Account Name
	else
		return tostring(zo_strformat("<<1>>", GetUnitName(unitTag))) -- CharName
	end
end
local function OnCombatEvent( _, result, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log, sourceUnitId, targetUnitId, abilityId, overflow )
	local unitTag = "Offline"
	if GROUP_UNITID[targetUnitId] ~= nil then unitTag = GROUP_UNITID[targetUnitId] end	
	if result == ACTION_RESULT_EFFECT_GAINED then -- 2240
		if SYNERGYLIST[abilityId] ~= nil then 								
			if GROUP_INFO[unitTag] ~= nil then 
				GROUP_INFO[unitTag].cdList[SYNERGYLIST[abilityId].id].cd = (GetGameTimeMilliseconds()/1000) + (SYNERGYLIST[abilityId].cd/1000)
				GROUP_INFO[unitTag].cdList[SYNERGYLIST[abilityId].id].start = (GetGameTimeMilliseconds()/1000)
			end	
		end
	end	
end
local function TTrackUpdateCooldown()
	for GRI = 1, GetGroupSize() do
		local unitTag = "group"..GRI
		local TTName = BSCGetUnitName(unitTag)
		if BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName] and BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].ENABLED then 
			local INFO = GetInfoForUpdateSettings(TTName)
			for SID = 1, SYNGERY_COUNT do
				if INFO[SID].enable then
					local DURATION = GROUP_INFO[unitTag].cdList[SID].cd - (GetGameTimeMilliseconds()/1000)							
					local UI_FILL = 120
					local BG_R = 255
					local BG_G = 0
					if DURATION > 0 then 
						UI_FILL = DURATION/(GROUP_INFO[unitTag].cdList[SID].cd-GROUP_INFO[unitTag].cdList[SID].start) * 120
						if UI_FILL < 0 then UI_FILL = 0 end
						BG_R = (UI_FILL > (120 / 2) and (UI_FILL *2/(120 / 4))) or 1
						BG_G = (UI_FILL < (120 / 2) and (UI_FILL *2/(120 / 3))) or 1
						BSCAS.TTframes[GRI].panels[SID].cd:SetText(string.format("%.1f", DURATION))
					else
						BSCAS.TTframes[GRI].panels[SID].cd:SetText(string.format("%.1f", 0))
					end				
					BSCAS.TTframes[GRI].panels[SID].fill:SetWidth(UI_FILL)
					BSCAS.TTframes[GRI].panels[SID].fill:SetCenterColor(BG_R, BG_G, 0, 0.60)					
				end
			end
		end
	end
end
function BSCAS.TTrackUpdateSetting() -- /script BSCASynergy.TTrackUpdateSetting()
	-- Check if there is a player we want to track
	local GroupSize = GetGroupSize()
	for GRI = 1, BSC_GROUP_SIZE_MAX do		
		BSCAS.TTframes[GRI].frame:SetHidden(true)		
		if BSCAS.SV.TARGET_TRACKING_ENABLED and GroupSize >= GRI then
			local unitTag = "group"..GRI
			local TTName = BSCGetUnitName(unitTag)
			if TTName ~= nil and TTName ~= "" then
				if BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName] and BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].ENABLED then -- /script d(BSCASynergy.SV.TARGET_TRACKING_UI_PLAYER["@BSC's_ADDONTEST"]) /script BSCASynergy.TTrackUpdateSetting() /script d(GetUnitName("group2"))
					BSCAS.TTframes[GRI].frame:SetHidden(false)
					BSCAS.TTframes[GRI].frame:GetNamedChild("Name"):SetText(TTName)	
					BSCAS.TTframes[GRI].frame:ClearAnchors()
					BSCAS.TTframes[GRI].frame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].UI_LEFT, BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].UI_TOP)				
					local INFO = GetInfoForUpdateSettings(TTName)
					
					local oldpan = nil
					for SID = 1, SYNGERY_COUNT do
						if INFO[SID].enable then 
							local panel = BSCAS.TTframes[GRI].panels[SID].panel
							BSCAS.TTframes[GRI].panels[SID].id = SID
							BSCAS.TTframes[GRI].panels[SID].icon:SetTexture(INFO[SID].icon)
							BSCAS.TTframes[GRI].panels[SID].name:SetText(INFO[SID].name)
							BSCAS.TTframes[GRI].panels[SID].panel:SetHidden(false)
							BSCAS.TTframes[GRI].panels[SID].panel:ClearAnchors()
							if oldpan == nil then
								BSCAS.TTframes[GRI].panels[SID].panel:SetAnchor(TOPLEFT, BSCAS.TTframes[GRI].frame, TOPLEFT, 0, 0)
							else
								BSCAS.TTframes[GRI].panels[SID].panel:SetAnchor(TOPLEFT, oldpan, BOTTOMLEFT, 0, 0)
							end
							oldpan = panel
						else
							BSCAS.TTframes[GRI].panels[SID].id = -1
							BSCAS.TTframes[GRI].panels[SID].panel:SetHidden(true)
						end
					end				
					SCENE_MANAGER:GetScene("hud"):AddFragment(BSCAS.TTfragments[GRI])
					SCENE_MANAGER:GetScene("hudui"):AddFragment(BSCAS.TTfragments[GRI])	
				else
					SCENE_MANAGER:GetScene("hud"):RemoveFragment(BSCAS.TTfragments[GRI])
					SCENE_MANAGER:GetScene("hudui"):RemoveFragment(BSCAS.TTfragments[GRI])
				end
			end
		end
	end	
end
function BSCAS.OnMoveStopTT(GRI, frame)
	local unitTag = "group"..GRI
	local TTName = BSCGetUnitName(unitTag)
	if not BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName] then return end
	BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].UI_LEFT = frame:GetLeft()
	BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].UI_TOP = frame:GetTop()
end
local function CreateUI()	
	local WM = GetWindowManager()
	BSCAS.TTframes = { }	
	BSCAS.TTfragments = { }
	for GRI = 1, BSC_GROUP_SIZE_MAX do
		local frame = WM:CreateControlFromVirtual("BSCASynergyTTUIF" .. GRI, nil, "BSCASynergyTTUIF")
		frame:SetHandler("OnMoveStop", function() BSCASynergy.OnMoveStopTT(GRI, frame) end)		
		frame:GetNamedChild("Name"):SetText("Testing "..GRI)
		BSCAS.TTframes[GRI] = {
			frame = frame,
			panels = {},
		}		
		local oldpan = nil
		for SID = 1, SYNGERY_COUNT do
			local panel = WM:CreateControlFromVirtual("BSCASynergyTTUIP" .. GRI .. "_" .. SID, frame, "BSCASynergyTTUIP")						
			BSCAS.TTframes[GRI].panels[SID] = {
				panel = panel,
				bg = panel:GetNamedChild("Backdrop"),
				icon = panel:GetNamedChild("Icon"),
				name = panel:GetNamedChild("Name"),
				fill = panel:GetNamedChild("Fill"),
				cd = panel:GetNamedChild("Cooldown"),
				id = -1,
			}
			BSCAS.TTframes[GRI].panels[SID].bg:SetEdgeColor(0, 0, 0, 0)
			BSCAS.TTframes[GRI].panels[SID].bg:SetCenterColor(0, 0, 0, 0.5)
			BSCAS.TTframes[GRI].panels[SID].cd:SetColor(1, 1, 1, 1)
			BSCAS.TTframes[GRI].panels[SID].cd:SetText("0")	
			BSCAS.TTframes[GRI].panels[SID].fill:SetCenterColor(255, 0, 0, 0.40)	
			if SID == 1 then
				BSCAS.TTframes[GRI].panels[SID].panel:SetAnchor(TOPLEFT, frame, TOPLEFT, 0, 0)
			else
				BSCAS.TTframes[GRI].panels[SID].panel:SetAnchor(TOPLEFT, oldpan, BOTTOMLEFT, 0, 0)
			end
			oldpan = panel
		end
		frame:ClearAnchors()
		frame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 200, 200)	
		BSCAS.TTfragments[GRI] = ZO_HUDFadeSceneFragment:New(frame)
	end
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- //////////////////////////////////////////////// --- Group -- /////////////////////////////////////////////////////
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCAS:GetGroupListNames() -- /script d(BSCASynergy:GetGroupListNames())
	local List = {}	
	for i = 1, BSC_GROUP_SIZE_MAX do		
		local TTName = BSCGetUnitName("group"..i)
		if TTName ~= nil and TTName ~= "" then
			table.insert(List, TTName)
		end
	end	
	return List
end
local bUpdateGroupAfterCombat = false
local function GroupUpdate()
	if IsUnitInCombat("player") then 
		bUpdateGroupAfterCombat = true
		return 
	end
	BSCAS.TTrackUpdateSetting()
	bUpdateGroupAfterCombat = false
	if BSCAS_TTrackingDropdownG ~= nil then
		BSCAS_TTrackingDropdownG:UpdateChoices(BSCAS:GetGroupListNames())
	end
end
function BSCAS:CallUpdateAfterCombatTT()
	if bUpdateGroupAfterCombat then GroupUpdate() end
end
local function GroupRangeUpdate(unitTag, status)	
	if not IsUnitPlayer(unitTag) then return end
	local GRI = GetGroupIndexByUnitTag(unitTag) 
	local unitTag = "group"..GRI
		local TTName = BSCGetUnitName(unitTag)
		if TTName ~= nil and TTName ~= "" then
		if BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName] and BSCAS.SV.TARGET_TRACKING_UI_PLAYER[TTName].ENABLED then			
			for SID = 1, SYNGERY_COUNT do
				if status then
					BSCAS.TTframes[GRI].panels[SID].panel:SetAlpha(1)
				else
					BSCAS.TTframes[GRI].panels[SID].panel:SetAlpha(0.5)
				end
			end
		end
	end
end
local function OnEffectChanged(_, _, _, _, unitTag, _, _, _, _, _, _, _, _, unitName, unitId, _, _)
	if not IsUnitPlayer(unitTag) then return end
	if GROUP_INFO[unitTag] ~= nil then 
		GROUP_INFO[unitTag].unitId = unitId
		GROUP_UNITID[unitId] = unitTag
	end
end
local function GroupInit()
	GROUP_UNITID = { }
	for i = 1, BSC_GROUP_SIZE_MAX do
		local unitTag = "group"..i
		GROUP_INFO[unitTag] = { }
		GROUP_INFO[unitTag].unitId = -1
		GROUP_INFO[unitTag].cdList = { }
		for ListId = 1, SYNGERY_COUNT do
			GROUP_INFO[unitTag].cdList[ListId] = { }
			GROUP_INFO[unitTag].cdList[ListId].cd = 0
			GROUP_INFO[unitTag].cdList[ListId].start = 0
		end
	end
end
function BSCAS.TargetTrackEnable()
	if BSCAS.SV.TARGET_TRACKING_ENABLED then 		
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_TRTROEC'..abilityId
			EVENT_MANAGER:RegisterForEvent(eventName, EVENT_COMBAT_EVENT, OnCombatEvent)
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, abilityId)			
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_NONE)		
		end				
		EVENT_MANAGER:RegisterForUpdate('BSCAS_TargetTrackUpdate', BSCAS.UPDATE_INTERVAL, TTrackUpdateCooldown)
		local eventName = 'BSCAS_TRTROEC'
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_MEMBER_JOINED, function(...) zo_callLater(function() GroupUpdate() end, 1500) end) 
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_MEMBER_LEFT, function(...) zo_callLater(function() GroupUpdate() end, 1500) end)	
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_GROUP_SUPPORT_RANGE_UPDATE, function(eventCode, unitTag, status) GroupRangeUpdate(unitTag, status) end)			
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_EFFECT_CHANGED, OnEffectChanged)
		EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG_PREFIX, "group")		
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_PLAYER_ACTIVATED, function(...) zo_callLater(function() GroupUpdate() end, 1500) end)
	else	
		for abilityId in pairs(SYNERGYLIST) do
			local eventName = 'BSCAS_TRTROEC'..abilityId
			EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_COMBAT_EVENT)
		end
		EVENT_MANAGER:UnregisterForUpdate('BSCAS_TargetTrackUpdate')		
		local eventName = 'BSCAS_TRTROEC'
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_MEMBER_JOINED)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_MEMBER_LEFT)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_GROUP_SUPPORT_RANGE_UPDATE)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_EFFECT_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_PLAYER_ACTIVATED)
	end	
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- //////////////////////////////////////////////// --- Init -- //////////////////////////////////////////////////////
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCAS.TargetTrackInit()
	CreateSynergylist()
	GroupInit()
	CreateUI()
	--
	BSCAS.InitTargetTrackingMenu()	
	BSCAS.TargetTrackEnable()
end
