-- preset (account wide)
ZO_CreateStringId("SI_SYNERGY_NAME_PRE", "Пресет")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_H", "Пресет (для всей учетной записи)")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_N", "Название пресета:")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_S", "Выбранный пресет:")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_B_S", "Добавить новый пресет")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_B_D", "Удалить пресет")
ZO_CreateStringId("SI_SYNERGY_NAME_PRE_B_L", "Загрузить пресет")
ZO_CreateStringId("SI_SYNERGY_ERROR_NOTDELETE", "Пресет [Default] не может быть удален!")
ZO_CreateStringId("SI_SYNERGY_ERROR_DELETE", "Пресет не существует!")
ZO_CreateStringId("SI_SYNERGY_INFO_RELOAD", "Это вызовет ReloadUI!")

-- base (char bound)
ZO_CreateStringId("SI_SYNERGY_NAME_BASE", "Настройки синергии")
ZO_CreateStringId("SI_SYNERGY_NAME_BAR", "Синергия только на основной панели")
ZO_CreateStringId("SI_SYNERGY_NAME_USEPVP", "Испольовать этот аддон в PvP?")
ZO_CreateStringId("SI_SYNERGY_NAME_LOKKE_CHECK", "Проверка 5-го бонуса сета Локкестиза")
ZO_CreateStringId("SI_SYNERGY_NAME_LOKKE_INFO", "Если Сет Локкестиза не используется, этот параметр будет проигнорирован. Для этого не нужен параметр «только на основной панели».")

-- submenu names
ZO_CreateStringId("SI_SYNERGY_NAME_CLASSES", "Классовые синергии")
ZO_CreateStringId("SI_SYNERGY_NAME_RAID", "Рейдовые синергии")
ZO_CreateStringId("SI_SYNERGY_NAME_TRANSFORM", "Трансформация (Оборотень и Вампир)")
ZO_CreateStringId("SI_SYNERGY_NAME_ITEMS", "Сетовые синергии")

-- Resources
ZO_CreateStringId("SI_SYNERGY_NAME_RESOURCE", "Ресурсы")
ZO_CreateStringId("SI_SYNERGY_NAME_RESOURCE_ENABLE", "Включить проверку ресурсов")
ZO_CreateStringId("SI_SYNERGY_NAME_RESOURCE_SLIDER", "Процент ресурсов")
ZO_CreateStringId("SI_SYNERGY_NAME_RESOURCE_TIP", "Если ниже (ваша максимальная мана/выносливость) используются разблокированные синергии")

-- Alkosh
ZO_CreateStringId("SI_SYNERGY_NAME_ALKOSH", "Настройки Алкоша")
ZO_CreateStringId("SI_SYNERGY_ALKOSHUI", "Включить отслеживание Алкоша на UI")
ZO_CreateStringId("SI_SYNERGY_ALKOSH_LIST", "Список Алкоша")
ZO_CreateStringId("SI_SYNERGY_ALKOSH_COUNT", "Мин. "..(MAX_BOSSES-1).." = Только боссы")
ZO_CreateStringId("SI_SYNERGY_SOUND_VOLL", "Громкость звука")
ZO_CreateStringId("SI_SYNERGY_SOUND_TEST", "Проверка звука")
ZO_CreateStringId("SI_SYNERGY_UI_MARK_BOSS", " (Только для боссов)")
ZO_CreateStringId("SI_SYNERGY_ALKOSH_PRINT", "Отправлять длительность в чат")
ZO_CreateStringId("SI_SYNERGY_ALKOSH_PRINT_INFO", "Отправляет длительность Алкоша в чат после окончания боя")

-- synergy tooltip
ZO_CreateStringId("SI_SYNERGY_TOOLTIP", "ВКЛ = можно использовать синергию!")
ZO_CreateStringId("SI_SYNERGY_IGNORE", "Игнорировать проверки")
ZO_CreateStringId("SI_SYNERGY_IGNORE_TT", "Игнорируйте панель навыков, Локкестиза и проверку ресурсов для этой синергии")
ZO_CreateStringId("SI_SYNERGY_MI_HOTBAR_INFO", "Синергия может использоваться только на выбранной панели.")

-- Major Slayer UI
ZO_CreateStringId("SI_SYNERGY_NAME_MSLAYER", "Настройка Великой жажды убийств")
ZO_CreateStringId("SI_SYNERGY_MSLAYERUI", "Включить отслеживание Великой ЖУ на UI")
ZO_CreateStringId("SI_SYNERGY_SLAYER_DNAME", "Показать название")
ZO_CreateStringId("SI_SYNERGY_SLAYER_DICON", "Показать иконку")
ZO_CreateStringId("SI_SYNERGY_SLAYER_HIDE", "Скрыть, пока бафф неактивен")

-- UI Settings
ZO_CreateStringId("SI_SYNERGY_NAME_SOUND_ON_OFF", "Воспроизвести звук")
ZO_CreateStringId("SI_SYNERGY_NAME_SOUND_CHOOSE", "Выберите звук")
ZO_CreateStringId("SI_SYNERGY_NAME_SOUND_TIME", "Воспроизвести по оставшемуся времени X секунд")
ZO_CreateStringId("SI_SYNERGY_UI_WIDTH", "Ширина UI")
ZO_CreateStringId("SI_SYNERGY_UI_HIGHT", "Высота UI")
ZO_CreateStringId("SI_SYNERGY_UI_SHOW", "Показать UI")
ZO_CreateStringId("SI_SYNERGY_UI_MARK", "Показать маркировку")
ZO_CreateStringId("SI_SYNERGY_UI_MARK_DESC", "Маркировка - это тонкая линия, на которой вы желаете обновить бафф..")
ZO_CreateStringId("SI_SYNERGY_UI_RESET", "Сброс UI")
ZO_CreateStringId("SI_SYNERGY_UI_LOCK", "Заблокировать UI")

-- UI Tracking
ZO_CreateStringId("SI_SYNERGY_UI_TRACK_SETTINGS", "Настройки отслеживания")
ZO_CreateStringId("SI_SYNERGY_UI_TRACK_ENABLE", "Включить отслеживание")
ZO_CreateStringId("SI_SYNERGY_UI_TRACK_ORIENT", "Ориентация")
ZO_CreateStringId("SI_SYNERGY_UI_TRACK_SIZE", "Размер")
ZO_CreateStringId("SI_SYNERGY_UI_TRACK_SIZE_OUTLINE", "Размер фона")

------------------------------------------------------------------------------
-- Undaunted
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_UNDAUNTED", "Неустрашимые")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_TEMPLAR", "Храмовник")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_SORC", "Чародей")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_DK", "Рыцарь-Дракон")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_NB", "Клинок Ночи")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_WARDN", "Хранитель")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_NECRO", "Некромант")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- VAMP
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TREE_WOLF", "Вервольф")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Trail Cloutrest
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TRAIL_CR", "Клаудрест")
ZO_CreateStringId("SI_SYNERGY_DEBUFF_TRAIL_CR", "Автоблокировка при дебаффе")
ZO_CreateStringId("SI_SYNERGY_DEBUFF_TRAIL_CR_DESC", "Блокирует синергию, пока у вас есть дебафф, и снова включает его, когда он исчезает.")
------------------------------------------------------------------------------
-- Trail HRC
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TRAIL_HRC", "Цитадель Хель-Ра")
ZO_CreateStringId("SI_SYNERGY_ALERT_HRC", "Нажмите Подтвердить, чтобы включить синергию.") --
ZO_CreateStringId("SI_SYNERGY_NAME_DESTRUCTIVE_OUTBREAK", "Диалоговое окно подтверждения взрыва")
------------------------------------------------------------------------------
-- Trail SS
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TRAIL_SS", "Солнечный Шпиль")
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Trail KA
------------------------------------------------------------------------------
ZO_CreateStringId("SI_SYNERGY_NAME_TRAIL_KA", "Эгида Кин")
------------------------------------------------------------------------------
-- BRP + MSA SIGILS
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- not used
----------- TRIAL SYNERGIES -----------
ZO_CreateStringId("SI_SYNERGY_ABILITY_SHED_HOARFROST", "Shed Hoarfrost") -- CR Hoarfrost
ZO_CreateStringId("SI_SYNERGY_ABILITY_MALEVOLENT_CORE", "Malevolent Core") -- CR downstairs cores
ZO_CreateStringId("SI_SYNERGY_ABILITY_WIND_OF_THE_WELKYNAR", "Wind of the Welkynar") -- CR downstairs jump pads
ZO_CreateStringId("SI_SYNERGY_ABILITY_WELKYNARS_LIGHT", "Welkynar's Light") -- CR spears
ZO_CreateStringId("SI_SYNERGY_ABILITY_POWER_SWITCH", "Power Switch") -- hof boss 2 switch
ZO_CreateStringId("SI_SYNERGY_ABILITY_LEVITATE", "Levitate") -- hof boss 2 pads
ZO_CreateStringId("SI_SYNERGY_ABILITY_CELESTIAL_PURGE", "Celestial Purge") -- vmol something
ZO_CreateStringId("SI_SYNERGY_ABILITY_REMOVE_BOLT", "Remove Bolt") -- Ozara pin


----------- BOSSES -----------
ZO_CreateStringId("SI_SYNERGY_BOSS_THE_MAGE", "Маг")
ZO_CreateStringId("SI_SYNERGY_BOSS_YOKEDA_KAI", "Йокеда Кай")
ZO_CreateStringId("SI_SYNERGY_BOSS_YOKEDA_ROKDUN", "Йокеда Рок'Дун")
ZO_CreateStringId("SI_SYNERGY_BOSS_ASSEMBLY_GENERAL", "Сборочный Генерал")

ZO_CreateStringId("SI_SYNERGY_BOSS_YOLNAHKRIIN", "Йолнокриин")
ZO_CreateStringId("SI_SYNERGY_BOSS_LOKKESTIIZ", "Локкестииз")
ZO_CreateStringId("SI_SYNERGY_BOSS_NAHVIINTAAS", "Наавинтас") 